package com.example.tests;

import java.util.concurrent.TimeUnit;
import org.junit.*;
import static org.junit.Assert.assertEquals;
import static org.junit.Assert.fail;
import org.openqa.selenium.*;
import org.openqa.selenium.firefox.FirefoxDriver;

public class AlertTestCase {
  private WebDriver driver;
  private boolean acceptNextAlert = true;
  private StringBuffer verificationErrors = new StringBuffer();

  @Before
  public void setUp() throws Exception {
    driver = new FirefoxDriver();
    driver.manage().timeouts().implicitlyWait(30, TimeUnit.SECONDS);
  }

  @Test
  public void testAlertTestCase() throws Exception {
    driver.get("http://localhost:8080/Web_Project_1/seleniumTest.jsp");
    driver.findElement(By.linkText("Popup Window Demos")).click();
    
    driver.findElement(By.cssSelector("button")).click();
    assertEquals("I am an alert box!", closeAlertAndGetItsText());
    
    driver.findElement(By.xpath("//button[@onclick='myFunction1()']")).click();
    assertEquals("Press a button!", closeAlertAndGetItsText());
    String pageSource = driver.getPageSource();
    int index = pageSource.indexOf("You pressed OK!");
    boolean contains = index >= 0;
    assertEquals(contains, true);
    
    
    driver.findElement(By.xpath("//button[@onclick='myFunction2()']")).click();
    Alert alert = driver.switchTo().alert();
    alert.sendKeys("Mickey");
    String alertText = alert.getText();
    alert.accept();
    assertEquals("Please enter your name", alertText);
    
    // ERROR: Caught exception [ERROR: Unsupported command [getPrompt |  | ]]
    driver.findElement(By.xpath("//a[contains(@href, 'smallPopup.html')]")).click();
  }

  @After
  public void tearDown() throws Exception {
    driver.quit();
    String verificationErrorString = verificationErrors.toString();
    if (!"".equals(verificationErrorString)) {
      fail(verificationErrorString);
    }
  }

  private boolean isElementPresent(By by) {
    try {
      driver.findElement(by);
      return true;
    } catch (NoSuchElementException e) {
      return false;
    }
  }

  private boolean isAlertPresent() {
    try {
      driver.switchTo().alert();
      return true;
    } catch (NoAlertPresentException e) {
      return false;
    }
  }

  private String closeAlertAndGetItsText() {
    try {
      Alert alert = driver.switchTo().alert();
      String alertText = alert.getText();
      if (acceptNextAlert) {
        alert.accept();
      } else {
        alert.dismiss();
      }
      return alertText;
    } finally {
      acceptNextAlert = true;
    }
  }
}
